﻿#################
# Ersteller: P. Hess
# Datum: 9. Juni 2022
# Version: 1.0
#################

<#

.synopsis
Script for Computer-Analysation

.description
Use of the Classes find by the Get-WmiObject

Path and Name of the output-file

.notes
Historie:
Version Date     Responsible Remark
1.1     23.6.22  P. Hess     Parameter added


#> 
param (
  $Path = "C:\PSScripts",
  $Name = "myComputer.txt"
)
$altPath = Read-Host "Please define the path für the output! Default: C:\PSScripts"

if ($altPath -ne "") {
  $path = $altPath
}
$target = $path + "\" + $name

# Erstellen eines PSDrives myDrive, falls es ihn noch nicht gibt
$drive = Get-PsDrive | Where-Object -Property Name -eq -Value "myDrive"
if ($drive -notin "myDrive") {
  New-PSDrive -name myDrive -psprovider FileSystem -root $path
}

# Setzen des aktuellen Ordners auf das PSDrive myDrive
set-location myDrive:

#control time
Write-Host "Local time:"
Get-CimInstance -ClassName Win32_LocalTime

# control timezone
"Timezone infos" > $target
Get-CimInstance -ClassName Win32_TimeZone >> $target
$town = Get-CimInstance -ClassName Win32_TimeZone
if ($town -match "Bern") {
  Write-Host -ForegroundColor Green "Zeitzone korrekt"
}
else {
  Write-Host -ForegroundColor Red "Zeitzone stimmt nicht"
}


#Hardware infos
"Hardware infos" >> $target
Get-CimInstance -ClassName Win32_ComputerSystem | Format-Table -AutoSize -Wrap >> $target
Get-CimInstance -ClassName Win32_Processor | Select-Object -ExcludeProperty "CIM*" | Format-Table -Autosize -Wrap >> $target
Get-CimInstance -ClassName Win32_Battery | Format-Table -Autosize -Wrap >> $target

#Drives info
"Drives infos" >> $target
get-CimInstance -Classname Win32_LogicalDisk >> $target

"Drives   Used Space" >> $target
"------   --------------" >> $target
get-CimInstance -Classname Win32_LogicalDisk | ForEach {

  $usedSpace = $_.Size - $_.FreeSpace
  [string] $diskOut = $_.DeviceID + "       " + $usedSpace
  $diskOut >> $target

}
" " >> $target

#USB infos
"USB infos" >> $target
get-CimInstance -Classname Win32_USBController >> $target
#get-CimInstance -Classname Win32_USBControllerDevice >> $target
#get-CimInstance -Classname Win32_USBHub >> $target


#Keyboard infos
"Keyboard infos" >> $target
get-CimInstance -Classname Win32_Keyboard >> $target

#OS infos
"OS infos" >> $target
get-CimInstance -Classname Win32_OperatingSystem >> $target
"OS infos quick fixes" >> $target
get-CimInstance -Classname Win32_QuickFixEngineering | Sort-Object HotFixID -Descending  >> $target

#BIOS info
"BIOS infos" >> $target
Get-CimInstance -ClassName Win32_BIOS >> $target

#Network info
"Network infos" >> $target
#Get-CimInstance -ClassName Win32_NetworkProtocol >> $target
Get-CimInstance -ClassName Win32_NetworkAdapter >> $target
#Get-CimInstance -ClassName Win32_NetworkClient >> $target


#Software infos
"Software infos" >> $target
Get-ItemProperty HKLM:\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\* |
Select-Object DisplayName, DisplayVersion | Sort-Object DisplayName | Format-Table -AutoSize -Wrap >> $target

#Additional software infos
#Get-ItemProperty HKLM:\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\* |
#Select-Object DisplayName, Publisher | Format-Table -AutoSize >> $target
#Get-ItemProperty HKLM:\Software\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall\* |
#Select-Object DisplayName, InstallDate | Format-Table -AutoSize >> $target